﻿/// <typ>StorageHelperType</typ>
/// <file>StorageHelperType.Events.cs</file>
/// <create>14.09.2011 22:57:12</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using StorageHelper.StorageLib;

namespace StorageHelper.StorageBase
{
		public partial class StorageHelperType
		{
				public delegate void StorageHelperEventHandler(StorageHelperType sender, StorageHelperEventArgs e);

				public event StorageHelperEventHandler SaveEvent;

				protected virtual void OnSaveEvent(StorageHelperEventArgs e)
				{
						StorageHelperEventHandler Event = SaveEvent;
						if (Event != null)
						{
								Event(this, e);
						}
				}

				public void Save()
				{
						if (isSticky)
								OnSaveEvent(new StorageHelperEventArgs(this.StateInfo));
				}

				public event StorageHelperEventHandler DeleteEvent;

				protected virtual void OnDeleteEvent(StorageHelperEventArgs e)
				{
						StorageHelperEventHandler Event = DeleteEvent;
						if (Event != null)
						{
								Event(this, e);
						}
				}

				public void Delete()
				{
						OnDeleteEvent(new StorageHelperEventArgs(this.StateInfo));
				}

				public event StorageHelperEventHandler ClearEvent;

				protected virtual void OnClearEvent(StorageHelperEventArgs e)
				{
						StorageHelperEventHandler Event = ClearEvent;
						if (Event != null)
						{
								Event(this, e);
						}
				}

				public void Clear()
				{
						OnClearEvent(new StorageHelperEventArgs(this.StateInfo));
				}
		}
}