﻿/// <typ>SimplXmlFile</typ>
/// <file>SimplXmlFile.cs</file>
/// <create>15.03.2011 17:37:12</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
#if DEPRICATED
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using StorageHelper.StorageLib;
using System.IO;
using System.Xml.Serialization;
using StorageHelper.StorageBase;

#if CF3_5
using FileWrapper = StorageHelper.CF3_5Wrapper;
#else
using FileWrapper = System.IO;

using StorageHelper.StorageLib.Depricated;

#endif

namespace StorageHelper.StorageEngines
{
		public class SimpleXmlFile_DEPRICATED : StorageEngine_DEPRICATED
		{
				public string FileExtension = ".xml";
				private string FileName;

				public override void Init()
				{
						if (!Directory.Exists(this.ConnectionString))
								throw new ConnectionStringNotExistingException(this.ConnectionString, this);
						if (CustomConfigParam != null && (string)CustomConfigParam != string.Empty)
								FileExtension = "." + (string)CustomConfigParam;
						foreach (string dir in this.SectionNames)
						{
								string tDir = ConnectionString + @"\" + dir;

								if (!Directory.Exists(tDir))
								{
										Directory.CreateDirectory(tDir);
								}
						}
						FileName = UniqID + FileExtension;
				}

				public override void Save()
				{
						FileName = UniqID + FileExtension;
						XmlSerializer serializer = new XmlSerializer(HostObject.GetType());

						StringWriter sw = new StringWriter();

						serializer.Serialize(sw, HostObject);
						string strg = sw.ToString();
						FileWrapper.File.WriteAllText(ConnectionString + "\\" + this.DefaultSectionName + "\\" + FileName, sw.ToString());
				}

				public override void Delete()
				{
						FileName = UniqID + FileExtension;
						File.Delete(FileName);
				}

				public override void Clear()
				{
						HostObject = (StorageHelperType_DEPRICATED)Activator.CreateInstance(this.HostType);
				}

				public override object GetObject(string _uniqID)
				{
						FileName = _uniqID + FileExtension;
						XmlSerializer serializer = new XmlSerializer(this.HostType);
						StringReader reader = new StringReader(
								FileWrapper.File.ReadAllText(ConnectionString + "\\" + this.DefaultSectionName + "\\" + FileName)
								);
						return serializer.Deserialize(reader);
				}

				public override List<Object> GetAllObjects()
				{
						string[] files = Directory.GetFiles(ConnectionString + "\\" + this.DefaultSectionName + "\\", "*" + FileExtension);

						List<object> ret = new List<object>();

						foreach (string file in files)
						{
								string uniq = file.Replace(ConnectionString + "\\" + this.DefaultSectionName + "\\", "");
								uniq = uniq.Replace(FileExtension, "");
								ret.Add(GetObject(uniq));
						}

						return ret;
				}

				public override int getNextAutoIncrement()
				{
						List<string> files = new List<string>();

						files.AddRange(Directory.GetFiles(ConnectionString + "\\" + this.DefaultSectionName + "\\", "*" + FileExtension));

						if (files.Count<string>() <= 0)
								return 1;

						int current = 1;

						files.Sort();

						foreach (string fl in files)
						{
								string clean = fl.Replace(ConnectionString + "\\" + this.DefaultSectionName + "\\", "");
								int digit = Convert.ToInt32(clean.Substring(0, IdDigits));
								if (current != digit)
										return current;
								else
										current++;
						}
						return current++;

						//string AutoFile = ConnectionString + "\\"+ this.DefaultSectionName + "\\" + "AutoIncrement.data";
						//int id;

						//if (!File.Exists(AutoFile))
						//  id = 1;
						//else
						//  id = Convert.ToInt32(FileWrapper.File.ReadAllText(AutoFile)) + 1;
						//FileWrapper.File.WriteAllText(AutoFile, id.ToString());
						//return id;
				}
		}
}
#endif